Bug 196590 - Yum removes and updates a pckage rather than just updating
Yum removes and updates a pckage rather than just updating
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: yum (Show other bugs)
5
All Linux
medium Severity high
: ---
: ---
Assigned To: Jeremy Katz
:
: 197906 214788 (view as bug list)
Depends On:
Blocks: FC6Blocker 196585 214865
  Show dependency treegraph
 
Reported: 2006-06-25 10:18 EDT by Jonathan Underwood
Modified: 2014-01-21 17:54 EST (History)
14 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-11-20 06:40:04 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Last 1000 lines of my yum.log (17.69 KB, text/plain)
2006-11-09 13:54 EST, Paul Dickson
no flags Details
output of 'rpm -vv -Uvh gdm-2.17.2-1.fc7.i386.rpm 2>/tmp/foo.txt' (69.81 KB, text/plain)
2006-11-10 10:08 EST, Tom London
no flags Details

  None (edit)
Description Jonathan Underwood 2006-06-25 10:18:31 EDT
Description of problem:
(See Bug #196585)

When yum updates and needs to remove a kernel (due to the installonlyn module),
it both removes and updates other packages in the transaction rather than just
updating. This clobbers configurations badly, and is quite serious. I have given
a detailed description in bug 196585 (as I initially thought it was a shorewall
packaging bug).

Version-Release number of selected component (if applicable):
yum-2.6.1-0.fc5


How reproducible:
Every time

Steps to Reproduce:
1. See Bug #196585 for a recipe to reproduce the bug.
2.
3.
  
Actual results:
Packages are removed and updated

Expected results:
Packages are updated

Additional info:
Comment 1 Jonathan Underwood 2006-06-25 11:06:26 EDT
To make life simpler, I'll reproduce the issue here.

Below is an example where a yum transaction needs to install a new kernel,
remove an old kernel and update another package (shorewall). However, rather
than updating shorewall, it is first removed and then updated:

==START==

[root@pasiphae etc]# cat yum/pluginconf.d/installonlyn.conf
[main]
tokeep = 3
enabled = 1

[root@pasiphae etc]# ls shorewall
accounting  continue  init        interfaces.rpmsave  Makefile  nat     policy 
   routestopped    start    stopped    tcrules  zones
actions     ecn       initdone    ipsec               masq      netmap 
providers  rules           started  tcclasses  tos
blacklist   hosts     interfaces  maclist             modules   params  proxyarp
  shorewall.conf  stop     tcdevices  tunnels
[root@pasiphae etc]# rpm -qa | grep kernel
kernel-smp-devel-2.6.16-1.2122_FC5
kernel-smp-2.6.16-1.2111_FC5
kernel-smp-2.6.16-1.2122_FC5
kernel-smp-devel-2.6.16-1.2133_FC5
kernel-smp-2.6.16-1.2133_FC5
kernel-smp-devel-2.6.16-1.2111_FC5
[root@pasiphae etc]# rpm -qa | grep shorewall
shorewall-3.0.7-1.fc5
[root@pasiphae etc]# yum update
Loading "installonlyn" plugin
Setting up Update Process
Setting up repositories
livna                                                                [1/5]
livna                     100% |=========================|  951 B    00:00
macromedia                                                           [2/5]
macromedia                100% |=========================|  951 B    00:00
core                                                                 [3/5]
core                      100% |=========================| 1.1 kB    00:00
updates                                                              [4/5]
updates                   100% |=========================|  951 B    00:00
extras                                                               [5/5]
extras                    100% |=========================| 1.1 kB    00:00
Reading repository metadata in from local files
Resolving Dependencies
--> Populating transaction set with selected packages. Please wait.
---> Downloading header for kernel-smp to pack into transaction set.
kernel-smp-2.6.17-1.2139_ 100% |=========================| 152 kB    00:00
---> Package kernel-smp.i686 0:2.6.17-1.2139_FC5 set to be installed
---> Downloading header for shorewall to pack into transaction set.
shorewall-3.0.8-1.fc5.noa 100% |=========================|  18 kB    00:00
---> Package shorewall.noarch 0:3.0.8-1.fc5 set to be updated
---> Downloading header for kernel-smp-devel to pack into transaction set.
kernel-smp-devel-2.6.17-1 100% |=========================| 821 kB    00:00
---> Package kernel-smp-devel.i686 0:2.6.17-1.2139_FC5 set to be installed
--> Running transaction check
--> Populating transaction set with selected packages. Please wait.
---> Package kernel-smp-devel.i686 0:2.6.16-1.2111_FC5 set to be erased
---> Package kernel-smp.i686 0:2.6.16-1.2111_FC5 set to be erased
--> Running transaction check

Dependencies Resolved

=============================================================================
 Package                 Arch       Version          Repository        Size
=============================================================================
Installing:
 kernel-smp              i686       2.6.17-1.2139_FC5  updates            15 M
 kernel-smp-devel        i686       2.6.17-1.2139_FC5  updates           4.5 M
Updating:
 shorewall               noarch     3.0.8-1.fc5      extras            203 k
Removing:
 kernel-smp              i686       2.6.16-1.2111_FC5  installed          39 M
 kernel-smp-devel        i686       2.6.16-1.2111_FC5  installed          14 M

Transaction Summary
=============================================================================
Install      2 Package(s)
Update       1 Package(s)
Remove       2 Package(s)
Total download size: 20 M
Is this ok [y/N]: y
Downloading Packages:
(1/3): kernel-smp-2.6.17- 100% |=========================|  15 MB    00:05
(2/3): shorewall-3.0.8-1. 100% |=========================| 203 kB    00:00
(3/3): kernel-smp-devel-2 100% |=========================| 4.5 MB    00:01
Running Transaction Test
Finished Transaction Test
Transaction Test Succeeded
Running Transaction
  Installing: kernel-smp-devel             ######################### [1/6]
  Installing: kernel-smp                   ######################### [2/6]
warning: /etc/shorewall/zones saved as /etc/shorewall/zones.rpmsave
warning: /etc/shorewall/tcdevices saved as /etc/shorewall/tcdevices.rpmsave
warning: /etc/shorewall/shorewall.conf saved as
/etc/shorewall/shorewall.conf.rpmsave
warning: /etc/shorewall/rules saved as /etc/shorewall/rules.rpmsave
warning: /etc/shorewall/policy saved as /etc/shorewall/policy.rpmsave
warning: /etc/shorewall/interfaces saved as /etc/shorewall/interfaces.rpmsave
warning: /etc/shorewall/blacklist saved as /etc/shorewall/blacklist.rpmsave
  Removing  : shorewall                    ######################### [3/6]
  Updating  : shorewall                    ###                      
[4/6]warning: /etc/shorewall/shorewall.conf created as
/etc/shorewall/shorewall.conf.rpmnew
  Updating  : shorewall                    ###                      
[4/6]warning: /etc/shorewall/tcdevices created as
/etc/shorewall/tcdevices.rpmnew  Updating  : shorewall                   
######################### [4/6]
  Cleanup   : kernel-smp-devel             ######################### [5/6]
  Cleanup   : kernel-smp                   ######################### [6/6]

Removed: kernel-smp.i686 0:2.6.16-1.2111_FC5 kernel-smp-devel.i686
0:2.6.16-1.2111_FC5
Installed: kernel-smp.i686 0:2.6.17-1.2139_FC5 kernel-smp-devel.i686
0:2.6.17-1.2139_FC5
Updated: shorewall.noarch 0:3.0.8-1.fc5
Complete!

==END==

Notice how shorewall was removed ?


Now, the same transaction without the kernel installation and removal:

==START==
[root@pasiphae shorewall]# rpm -qa | grep shorewall
shorewall-3.0.7-1.fc5
[root@pasiphae shorewall]# yum update
Loading "installonlyn" plugin
Setting up Update Process
Setting up repositories
livna                                                                [1/5]
macromedia                                                           [2/5]
core                                                                 [3/5]
updates                                                              [4/5]
extras                                                               [5/5]
Reading repository metadata in from local files
Resolving Dependencies
--> Populating transaction set with selected packages. Please wait.
---> Downloading header for shorewall to pack into transaction set.
shorewall-3.0.8-1.fc5.noa 100% |=========================|  18 kB    00:00
---> Package shorewall.noarch 0:3.0.8-1.fc5 set to be updated
--> Running transaction check

Dependencies Resolved

=============================================================================
 Package                 Arch       Version          Repository        Size
=============================================================================
Updating:
 shorewall               noarch     3.0.8-1.fc5      extras            203 k

Transaction Summary
=============================================================================
Install      0 Package(s)
Update       1 Package(s)
Remove       0 Package(s)
Total download size: 203 k
Is this ok [y/N]: y
Downloading Packages:
(1/1): shorewall-3.0.8-1. 100% |=========================| 203 kB    00:00
Running Transaction Test
Finished Transaction Test
Transaction Test Succeeded
Running Transaction
  Updating  : shorewall                    ###                      
[1/2]warning: /etc/shorewall/shorewall.conf created as
/etc/shorewall/shorewall.conf.rpmnew
  Updating  : shorewall                    ###                      
[1/2]warning: /etc/shorewall/tcdevices created as
/etc/shorewall/tcdevices.rpmnew  Updating  : shorewall                   
######################### [1/2]
  Cleanup   : shorewall                    ######################### [2/2]

Updated: shorewall.noarch 0:3.0.8-1.fc5
Complete!

==END==

This is as expected.
Comment 2 Jeremy Katz 2006-06-25 20:57:26 EDT
Awesome... we've been looking for a concrete reproducer on this for a while. 
Can you get the output adding '-d6' to the yum command?  And I'll try to
reproduce it locally at the office tomorrow
Comment 3 Jonathan Underwood 2006-06-26 09:07:47 EDT
I'm happy to, except there is one problem - to reproduce the system state I'll
need to reinstall kernel-smp-2.6.16-1.2111_FC5 and accompanying devel package -
however, these have vanished from the updates server - is there anyway of
getting hold of older updates? I could simply reduce tokeep = 2, but I suspect
the bug will not manifest itself then - can you let me know if there is anywhere
I can pick up the RPMs for 2111 ?
Comment 4 Jeremy Katz 2006-06-26 10:42:15 EDT
They're up at http://people.redhat.com/~katzj/oldkernel/ now
Comment 5 Jonathan Underwood 2006-06-26 14:35:32 EDT
OK, reverted to the state that shows the bug and did a yum update -d6. C+P of
the session follows:

[root@pasiphae ~]# uname -ar
Linux pasiphae.open.ac.uk 2.6.16-1.2133_FC5smp #1 SMP Tue Jun 6 01:52:09 EDT
2006 i686 i686 i386 GNU/Linux
[root@pasiphae ~]# rpm -qa | grep kernel
kernel-smp-devel-2.6.16-1.2122_FC5
kernel-smp-devel-2.6.16-1.2111_FC5
kernel-smp-2.6.16-1.2122_FC5
kernel-smp-devel-2.6.16-1.2133_FC5
kernel-smp-2.6.16-1.2133_FC5
kernel-smp-2.6.16-1.2111_FC5
[root@pasiphae ~]# rpm -qa | grep shorewall
shorewall-3.0.7-1.fc5
[root@pasiphae ~]# cat /etc/yum/pluginconf.d/installonlyn.conf
[main]
tokeep = 3
enabled = 1

[root@pasiphae ~]# yum -d6 update
Loading "installonlyn" plugin
Running "config" handler for "installonlyn" plugin
Yum Version: 2.6.1
COMMAND: yum -d6
Installroot: /
Setting up Update Process
Setting up repositories
livna                                                                [1/5]
Baseurl(s) for repo: ['http://rpm.livna.org/fedora/5/i386/',
'http://livna.cat.pdx.edu/fedora/5/i386/',
'http://wftp.tu-chemnitz.de/pub/linux/livna/fedora/5/i386/',
'http://ftp-stud.fht-esslingen.de/pub/Mirrors/rpm.livna.org/fedora/5/i386/',
'ftp://mirrors.tummy.com/pub/rpm.livna.org/fedora/5/i386/']
macromedia                                                           [2/5]
Baseurl(s) for repo: ['http://macromedia.rediris.es/rpm/']
core                                                                 [3/5]
Baseurl(s) for repo:
['http://www.mirrorservice.org/sites/download.fedora.redhat.com/pub/fedora/linux/core/5/i386/os/',
'http://www.mirror.ac.uk/mirror/fedora.redhat.com/5/i386/os/']
updates                                                              [4/5]
Baseurl(s) for repo:
['http://www.mirrorservice.org/sites/fedora.redhat.com/updates/5/i386/',
'http://www.mirror.ac.uk/mirror/fedora.redhat.com/updates/5/i386/']
extras                                                               [5/5]
Baseurl(s) for repo:
['http://www.mirrorservice.org/sites/download.fedora.redhat.com/pub/fedora/linux/extras/5/i386/']
Reading repository metadata in from local files
Setting up Package Sacks
Reading Local RPMDB
Building updates object
putting kdevelop in complex update
putting libtiff in complex update
putting thunderbird in complex update
putting cups in complex update
putting kdelibs in complex update
putting kernel-smp-devel in complex update
putting kernel-smp in complex update
putting ruby in complex update
putting kdepim in complex update
putting autofs in complex update
putting selinux-policy in complex update
putting glibc in complex update
putting arts in complex update
putting avahi-glib in complex update
putting tetex in complex update
putting dhcdbd in complex update
putting libsepol in complex update
putting shadow-utils in complex update
putting spamassassin in complex update
putting cups-libs in complex update
putting gnome-panel in complex update
putting firefox in complex update
putting tetex-fonts in complex update
putting kdebindings in complex update
putting libtiff-devel in complex update
putting xterm in complex update
putting tetex-doc in complex update
putting totem in complex update
putting gtk2 in complex update
putting tetex-latex in complex update
putting avahi in complex update
putting kdesdk in complex update
putting gnome-session in complex update
putting tetex-afm in complex update
putting gdm in complex update
putting shorewall in complex update
putting libselinux in complex update
putting openssl in complex update
putting rsync in complex update
putting tetex-dvips in complex update
putting gnome-screensaver in complex update
putting arts-devel in complex update
putting kdelibs-apidocs in complex update
putting tetex-xdvi in complex update
putting gnome-themes in complex update
putting policycoreutils in complex update
putting kernel-smp in complex update
putting kdebase in complex update
putting kernel-smp-devel in complex update
putting dovecot in complex update
putting mysql in complex update
putting kdelibs-devel in complex update
putting ruby-libs in complex update
putting selinux-policy-targeted in complex update
putting evolution in complex update
putting libselinux-python in complex update
putting shared-mime-info in complex update
processing kdevelop
processing libtiff
processing thunderbird
processing cups
processing kdelibs
processing kernel-smp-devel
processing kernel-smp.i686
processing ruby
processing kdepim
processing autofs
processing selinux-policy
processing glibc.i686
processing arts
processing avahi-glib
processing tetex
processing dhcdbd
processing libsepol
processing shadow-utils
processing spamassassin
processing cups-libs
processing gnome-panel
processing firefox
processing tetex-fonts
processing kdebindings
processing libtiff-devel
processing xterm
processing tetex-doc
processing totem
processing gtk2
processing tetex-latex
processing avahi
processing kdesdk
processing gnome-session
processing tetex-afm
processing gdm
processing shorewall
processing libselinux
processing openssl
processing rsync
processing tetex-dvips
processing gnome-screensaver
processing arts-devel
processing kdelibs-apidocs
processing tetex-xdvi
processing gnome-themes
processing policycoreutils
processing kernel-smp.i686
processing kdebase
processing kernel-smp-devel
processing dovecot
processing mysql
processing kdelibs-devel
processing ruby-libs
processing selinux-policy-targeted
processing evolution
processing libselinux-python
processing shared-mime-info
Resolving Dependencies
1151346925.83
--> Populating transaction set with selected packages. Please wait.
Member: kernel-smp.i686 0-2.6.17-1.2139_FC5 - u
---> Downloading header for kernel-smp to pack into transaction set.
kernel-smp-2.6.17-1.2139_ 100% |=========================| 152 kB    00:00
kernel-smp - 2.6.17-1.2139_FC5.i686 converted to install
Adding Package kernel-smp - 2.6.17-1.2139_FC5.i686 in mode i
---> Package kernel-smp.i686 0:2.6.17-1.2139_FC5 set to be installed
Member: shorewall.noarch 0-3.0.8-1.fc5 - u
---> Downloading header for shorewall to pack into transaction set.
shorewall-3.0.8-1.fc5.noa 100% |=========================|  18 kB    00:00
Adding Package shorewall - 3.0.8-1.fc5.noarch in mode u
---> Package shorewall.noarch 0:3.0.8-1.fc5 set to be updated
Member: kernel-smp-devel.i686 0-2.6.17-1.2139_FC5 - u
---> Downloading header for kernel-smp-devel to pack into transaction set.
kernel-smp-devel-2.6.17-1 100% |=========================| 821 kB    00:00
kernel-smp-devel - 2.6.17-1.2139_FC5.i686 converted to install
Adding Package kernel-smp-devel - 2.6.17-1.2139_FC5.i686 in mode i
---> Package kernel-smp-devel.i686 0:2.6.17-1.2139_FC5 set to be installed
--> Running transaction check
Running "postresolve" handler for "installonlyn" plugin
--> Populating transaction set with selected packages. Please wait.
Member: kernel-smp.i686 0-2.6.17-1.2139_FC5 - i
Member: kernel-smp-devel.i686 0-2.6.16-1.2111_FC5 - e
---> Package kernel-smp-devel.i686 0:2.6.16-1.2111_FC5 set to be erased
Removing Package kernel-smp-devel - 2.6.16-1.2111_FC5.i686
Member: shorewall.noarch 0-3.0.8-1.fc5 - u
Member: kernel-smp.i686 0-2.6.16-1.2111_FC5 - e
---> Package kernel-smp.i686 0:2.6.16-1.2111_FC5 set to be erased
Removing Package kernel-smp - 2.6.16-1.2111_FC5.i686
Member: kernel-smp-devel.i686 0-2.6.17-1.2139_FC5 - i
--> Running transaction check

Dependencies Resolved
1151346928.17

=============================================================================
 Package                 Arch       Version          Repository        Size
=============================================================================
Installing:
 kernel-smp              i686       2.6.17-1.2139_FC5  updates            15 M
 kernel-smp-devel        i686       2.6.17-1.2139_FC5  updates           4.5 M
Updating:
 shorewall               noarch     3.0.8-1.fc5      extras            203 k
Removing:
 kernel-smp              i686       2.6.16-1.2111_FC5  installed          39 M
 kernel-smp-devel        i686       2.6.16-1.2111_FC5  installed          14 M

Transaction Summary
=============================================================================
Install      2 Package(s)
Update       1 Package(s)
Remove       2 Package(s)
Total download size: 20 M
Is this ok [y/N]: y
Downloading Packages:
(1/3): kernel-smp-2.6.17- 100% |=========================|  15 MB    00:04
(2/3): shorewall-3.0.8-1. 100% |=========================| 203 kB    00:00
(3/3): kernel-smp-devel-2 100% |=========================| 4.5 MB    00:02
Running Transaction Test
Member: kernel-smp.i686 0-2.6.17-1.2139_FC5 - i
Adding Package kernel-smp - 2.6.17-1.2139_FC5.i686 in mode i
Member: kernel-smp-devel.i686 0-2.6.16-1.2111_FC5 - e
Removing Package kernel-smp-devel - 2.6.16-1.2111_FC5.i686
Member: shorewall.noarch 0-3.0.8-1.fc5 - u
Adding Package shorewall - 3.0.8-1.fc5.noarch in mode u
Member: kernel-smp.i686 0-2.6.16-1.2111_FC5 - e
Removing Package kernel-smp - 2.6.16-1.2111_FC5.i686
Member: kernel-smp-devel.i686 0-2.6.17-1.2139_FC5 - i
Adding Package kernel-smp-devel - 2.6.17-1.2139_FC5.i686 in mode i
Finished Transaction Test
Transaction Test Succeeded
Member: kernel-smp.i686 0-2.6.17-1.2139_FC5 - i
Adding Package kernel-smp - 2.6.17-1.2139_FC5.i686 in mode i
Member: kernel-smp-devel.i686 0-2.6.16-1.2111_FC5 - e
Removing Package kernel-smp-devel - 2.6.16-1.2111_FC5.i686
Member: shorewall.noarch 0-3.0.8-1.fc5 - u
Adding Package shorewall - 3.0.8-1.fc5.noarch in mode u
Member: kernel-smp.i686 0-2.6.16-1.2111_FC5 - e
Removing Package kernel-smp - 2.6.16-1.2111_FC5.i686
Member: kernel-smp-devel.i686 0-2.6.17-1.2139_FC5 - i
Adding Package kernel-smp-devel - 2.6.17-1.2139_FC5.i686 in mode i
Running Transaction
  Installing: kernel-smp-devel             ######################### [1/6]
  Installing: kernel-smp                   ######################### [2/6]
warning: /etc/shorewall/zones saved as /etc/shorewall/zones.rpmsave
warning: /etc/shorewall/tcdevices saved as /etc/shorewall/tcdevices.rpmsave
warning: /etc/shorewall/shorewall.conf saved as
/etc/shorewall/shorewall.conf.rpmsave
warning: /etc/shorewall/rules saved as /etc/shorewall/rules.rpmsave
warning: /etc/shorewall/policy saved as /etc/shorewall/policy.rpmsave
warning: /etc/shorewall/interfaces saved as /etc/shorewall/interfaces.rpmsave
warning: /etc/shorewall/blacklist saved as /etc/shorewall/blacklist.rpmsave
  Removing  : shorewall                    ######################### [3/6]
  Updating  : shorewall                    ###                      
[4/6]warning: /etc/shorewall/shorewall.conf created as
/etc/shorewall/shorewall.conf.rpmnew
  Updating  : shorewall                    ###                      
[4/6]warning: /etc/shorewall/tcdevices created as /etc/shorewall/tcdevices.rpmnew
  Updating  : shorewall                    ######################### [4/6]
  Cleanup   : kernel-smp-devel             ######################### [5/6]
  Cleanup   : kernel-smp                   ######################### [6/6]

Removed: kernel-smp.i686 0:2.6.16-1.2111_FC5 kernel-smp-devel.i686
0:2.6.16-1.2111_FC5
Installed: kernel-smp.i686 0:2.6.17-1.2139_FC5 kernel-smp-devel.i686
0:2.6.17-1.2139_FC5
Updated: shorewall.noarch 0:3.0.8-1.fc5
Complete!


After this, the corresponding entries in /var/log/yum.log are:
Jun 26 19:37:39 Installed: kernel-smp-devel.i686 2.6.17-1.2139_FC5
Jun 26 19:37:53 Installed: kernel-smp.i686 2.6.17-1.2139_FC5
Jun 26 19:37:55 Erased: shorewall
Jun 26 19:37:57 Updated: shorewall.noarch 3.0.8-1.fc5
Comment 6 Jeremy Katz 2006-06-27 22:31:10 EDT
Okay, this is bizarre.  So much for my theory of it being something somehow
related to the more explicit install + upgrade paths that installonlyn hits.

Paul -- really, at this point, all I can think is that we're somehow hitting
weirdness in rpmlib.  But a quick runthrough doesn't have me see anything. 
Thoughts on more debugging avenues?
Comment 7 Jonathan Underwood 2006-07-06 15:52:04 EDT
FWIW I saw the same bug manifested today in a transaction which installed a new
kernel and removed an old one. /var/log/yum.log below, which shows qt-designer
being removed and then upgraded:

Jul 06 15:00:27 Updated: openoffice.org-core.i386 1:2.0.2-5.16.2
Jul 06 15:01:12 Updated: qt.i386 1:3.3.6-0.3.fc5
Jul 06 15:01:15 Updated: libgssapi.i386 0.9-1.FC5
Jul 06 15:01:18 Updated: nfs-utils-lib.i386 1.0.8-4.FC5
Jul 06 15:02:38 Updated: qt-devel.i386 1:3.3.6-0.3.fc5
Jul 06 15:02:47 Updated: openoffice.org-calc.i386 1:2.0.2-5.16.2
Jul 06 15:02:55 Updated: apr-util.i386 1.2.7-1.1
Jul 06 15:02:58 Updated: openoffice.org-math.i386 1:2.0.2-5.16.2
Jul 06 15:02:59 Updated: eclipse-changelog-debuginfo.i386 1:2.1.0_fc-2
Jul 06 15:02:59 Erased: qt-designer
Jul 06 15:03:04 Updated: nfs-utils.i386 1:1.0.8-2.fc5
Jul 06 15:03:14 Updated: eclipse-changelog.i386 1:2.1.0_fc-2
Jul 06 15:03:16 Updated: openoffice.org-graphicfilter.i386 1:2.0.2-5.16.2
Jul 06 15:03:19 Updated: qt-designer.i386 1:3.3.6-0.3.fc5
Jul 06 15:03:23 Updated: openoffice.org-impress.i386 1:2.0.2-5.16.2
Jul 06 15:09:43 Installed: kernel-smp-devel.i686 2.6.17-1.2145_FC5
Jul 06 15:10:17 Installed: kernel-smp.i686 2.6.17-1.2145_FC5
Jul 06 15:10:22 Updated: openoffice.org-draw.i386 1:2.0.2-5.16.2
Jul 06 15:10:25 Updated: openoffice.org-writer.i386 1:2.0.2-5.16.2
Jul 06 15:10:25 Updated: openoffice.org-xsltfilter.i386 1:2.0.2-5.16.2

I don't think this brings any new information to the table, but thought I'd
mentiopn it anyway.
Comment 8 Jeremy Katz 2006-07-10 19:43:13 EDT
*** Bug 197906 has been marked as a duplicate of this bug. ***
Comment 9 Jonathan Underwood 2006-07-11 13:18:16 EDT
This is such a severe bug, with the capacity for leaving a system unbootable
(see reports which have been marked as dupes of this one) that I wonder if, in
the event that the issue with rpmlib can't be found, FC6 should ship without
installonlyn activated - that way there won't be any yum "update" transactions
which remove kernels, which seems to be the trigger for the bug. I realize this
is suboptimal, but it's preferable to leaving things as they are. Thoughts?
Comment 10 Jonathan Underwood 2006-07-11 13:21:14 EDT
Sorry - ignore that, I had forgotten this was an FC6Blocker :)
Comment 11 Michal Jaegermann 2006-07-14 13:10:36 EDT
I got the following today when updating few packages from "rawhide"
(yum-2.9.2-3):

Running Transaction
warning: /etc/sysconfig/prelink saved as /etc/sysconfig/prelink.rpmsave
  Removing  : prelink                      ####################### [ 1/10]
  Updating  : kernel-doc                   ####################### [ 2/10]
  Installing: kernel-devel                 ####################### [ 3/10]
  Updating  : prelink                      ####################### [ 4/10]
  Installing: kernel                       ####################### [ 5/10]
  Updating  : gdm                          ####################### [ 6/10]
  Cleanup   : kernel                       ####################### [ 7/10]
  Cleanup   : kernel-doc                   ####################### [ 8/10]
  Cleanup   : gdm                          ####################### [ 9/10]
  Cleanup   : kernel-devel                 ####################### [10/10]

The net effect was that /etc/sysconfig/prelink "vanished" renamed.

But when I backed off these updates and tried once again with debugging
output then, unfortunately, everything worked like it should.
Well, I could not restore entirely a kernel situation as I do not
have packages which were removed (kernel-2.6.17-1.2358.fc6).

Package versions before updates 2.6.17-1.2366.fc6 for kernel packages,
0.3.8-1 for prelink and 1:2.15.5-3.1 for gdm. After updates:
2.6.17-1.2396.fc6, 0.3.9-1 and 1:2.15.6-1 respectively.  All x86_64.
Comment 12 Jonathan Underwood 2006-08-10 09:40:08 EDT
Michal - I imagine that if you had reverted to an earlier kernel such that the
update transaction involved installing a new kernel and removing an old one, you
would have seen the issue again.

A suggestion: For rawhide, would it be possible to leave old kernels in the
repository (or another repository), so that we can easily check for this
situation arising with the test releases. 
Comment 13 Jeremy Katz 2006-10-09 16:56:54 EDT
Are you still seeing this with yum 3.0?  I haven't been able to reproduce it in
some trying today.  And a lot of things have changed in yum 3.0.
Comment 14 Michal Jaegermann 2006-10-09 17:25:06 EDT
> Are you still seeing this with yum 3.0?

I did not see that for a while but every time I tried to recreate
the condition on purpose I failed.  It is not so easy to repeat it
and I really cannot tell what was the trigger.  yum 3.0 is a few
days old so the question may be a bit premature. :-)

OTOH it was really a long time ago when I was adversely affected by
the issue.
Comment 15 Jonathan Underwood 2006-10-09 18:58:18 EDT
Life is a bit hectic currently, so I'm not currently running a rawhide box.
However, I would caution against the idea that the issue was fixed by yum 3.0,
given that it looked like the problem resided in rpmlibs rather than yum before.
Comment 16 Paul Dickson 2006-11-09 13:54:38 EST
Created attachment 140807 [details]
Last 1000 lines of my yum.log

I got hit by this in devel during the past week.

/etc/yum.conf ended up renamed /etc/yum.conf.rpmsave and yum wouldn't run.

I look through my yum.log.  Just before it occurred,there was a new version of
rpm loaded. In fact it looks like it started after updating rpm during yum's
run.  It continued for a couple of subsequent runs of yum, but after a couple
of days, it stopped occurring.	The system has been running for 18 days, so it
wasn't a reboot that occurred.
Comment 17 Michal Jaegermann 2006-11-09 14:21:19 EST
I found today after an rawhide update and in the same transaction:
....
  Removing  : texinfo
....
  Updating  : texinfo
....

There are no config files involved so in this case there are no
adverse consequences.

yum-3.0.1-1 and rpm-libs-4.4.2-35.fc7
Comment 18 Tom London 2006-11-09 14:53:12 EST
Ran into this with today's gdm update.  Originally filed here:
https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=214788

Running Transaction Test
Finished Transaction Test
Transaction Test Succeeded
Running Transaction
warning: /etc/pam.d/gdm saved as /etc/pam.d/gdm.rpmsave
 Removing  : gdm                          ######################### [1/2]
Updating  : gdm                                                    [2/2]
Updated: gdm.i386 1:2.17.2-1.fc7
Complete!

At this point, /etc/pam.d/gdm was 'not there'.
Comment 19 Tom London 2006-11-09 15:02:51 EST
I 'reverted' gdm using rpm and got the same problem:

[root@localhost packages]# rpm -Uvh --oldpackage gdm-2.17.1-1.fc7.i386.rpm
Preparing...                ########################################### [100%]
warning: /etc/pam.d/gdm saved as /etc/pam.d/gdm.rpmsave
   1:gdm                    ########################################### [100%]
[root@localhost packages]# 
[root@localhost packages]# ls -l /etc/pam.d/gdm*
-rw-r--r-- 1 root root 353 Nov  5 11:42 /etc/pam.d/gdm-autologin
-rw-r--r-- 1 root root 351 Sep 29 15:32 /etc/pam.d/gdm.old
-rw-r--r-- 1 root root 459 Nov  9 06:56 /etc/pam.d/gdm.rpmsave
-rw-r--r-- 1 root root 142 Nov  5 11:42 /etc/pam.d/gdmsetup
[root@localhost packages]# 

Does this 'clear' yum?
Comment 20 Ray Strode [halfline] 2006-11-09 16:31:51 EST
*** Bug 214788 has been marked as a duplicate of this bug. ***
Comment 21 Tom London 2006-11-10 10:08:01 EST
Created attachment 140890 [details]
output of 'rpm -vv -Uvh gdm-2.17.2-1.fc7.i386.rpm 2>/tmp/foo.txt'

Running rpm -vv -Uvh ' of latest gdm package reproduces this problem. Output
attached. 

Notice these lines:
D: fini      100644  1 (   0,	0)	 459 /etc/pam.d/gdm backup
warning: /etc/pam.d/gdm saved as /etc/pam.d/gdm.rpmsave

and

D: fini      100644  1 (   0,	0)	 351 /etc/pam.d/gdm;455493c5 skip

Appears that it 'forgot' that it moved /etc/pam.d/gdm out of the way....

Any additional useful info I can provide?

tom
Comment 22 Paul Nasrat 2006-11-10 10:31:30 EST
Tom if you rollback to gdm-2.17.1-1.fc7.i386 can you reproduce reliably?
Comment 23 Tom London 2006-11-10 10:39:20 EST
Yup. I get it on both the rollback and the 'rollforward'.

Same 'skip' message from both 'rpm -vv' runs.
Comment 24 Tom London 2006-11-11 13:42:45 EST
Reverting rpm (and friends) back to 4.4.2-32 makes this problem go away for me:

[root@localhost packages]# rpm -Uvh --oldpackage gdm-2.17.1-1*
Preparing...                ########################################### [100%]
   1:gdm                    ########################################### [100%]
[root@localhost packages]# ls -l /etc/pam.d/gdm*
-rw-r--r-- 1 root root 459 Nov 10 07:36 /etc/pam.d/gdm
-rw-r--r-- 1 root root 353 Nov  5 11:42 /etc/pam.d/gdm-autologin
-rw-r--r-- 1 root root 351 Sep 29 15:32 /etc/pam.d/gdm.old
-rw-r--r-- 1 root root 459 Nov 10 07:34 /etc/pam.d/gdm.rpmsave
-rw-r--r-- 1 root root 142 Nov  5 11:42 /etc/pam.d/gdmsetup
[root@localhost packages]# 

Notice: rpm doesn't complain about saving /etc/pam.d/gdm, and (more
importantly!) it doesn't clobber it.

Similarly,

[root@localhost packages]# rpm -Uvh gdm-2.17.2-1*
Preparing...                ########################################### [100%]
   1:gdm                    ########################################### [100%]
[root@localhost packages]# ls -l /etc/pam.d/gdm*
-rw-r--r-- 1 root root 459 Nov 10 07:36 /etc/pam.d/gdm
-rw-r--r-- 1 root root 353 Nov  8 09:50 /etc/pam.d/gdm-autologin
-rw-r--r-- 1 root root 351 Sep 29 15:32 /etc/pam.d/gdm.old
-rw-r--r-- 1 root root 459 Nov 10 07:34 /etc/pam.d/gdm.rpmsave
-rw-r--r-- 1 root root 142 Nov  8 09:50 /etc/pam.d/gdmsetup
[root@localhost packages]# 

What changed in rpm*-4.4.2-35.fc7?
Comment 25 Paul Nasrat 2006-11-20 06:33:04 EST
I've commited a fix for this which will be in tomorrows rawhide - please test.
Comment 26 Tom London 2006-11-21 09:36:26 EST
Cool.  Seems to fix, at least for the gdm case described above:

[root@localhost packages]# rpm -qa rpm\*
rpm-devel-4.4.2-36.fc7
rpm-libs-4.4.2-36.fc7
rpm-build-4.4.2-36.fc7
rpm-python-4.4.2-36.fc7
rpm-4.4.2-36.fc7
[root@localhost packages]# rpm -Uvh --oldpackage gdm-2.17.1-1*
Preparing...                ########################################### [100%]
   1:gdm                    ########################################### [100%]
[root@localhost packages]# ls -l /etc/pam.d/gdm*
-rw-r--r-- 1 root root 459 Nov 10 07:36 /etc/pam.d/gdm
-rw-r--r-- 1 root root 353 Nov  5 11:42 /etc/pam.d/gdm-autologin
-rw-r--r-- 1 root root 351 Sep 29 15:32 /etc/pam.d/gdm.old
-rw-r--r-- 1 root root 459 Nov 10 07:34 /etc/pam.d/gdm.rpmsave
-rw-r--r-- 1 root root 142 Nov  5 11:42 /etc/pam.d/gdmsetup
[root@localhost packages]# rpm -Uvh gdm-2.17.2-1*
Preparing...                ########################################### [100%]
   1:gdm                    ########################################### [100%]
[root@localhost packages]# ls -l /etc/pam.d/gdm*
-rw-r--r-- 1 root root 459 Nov 10 07:36 /etc/pam.d/gdm
-rw-r--r-- 1 root root 353 Nov  8 09:50 /etc/pam.d/gdm-autologin
-rw-r--r-- 1 root root 351 Sep 29 15:32 /etc/pam.d/gdm.old
-rw-r--r-- 1 root root 459 Nov 10 07:34 /etc/pam.d/gdm.rpmsave
-rw-r--r-- 1 root root 142 Nov  8 09:50 /etc/pam.d/gdmsetup
[root@localhost packages]# 

Notice both 'updates' above, /etc/pam.d/gdm is not 'saved', and after the
update, /etc/pam.d/gdm 'exists'.

Thanks!
   tom

Note You need to log in before you can comment on or make changes to this bug.